define(['require', 'https://d3js.org/d3.v5.min.js'], function (requirejs, d3) { 'use strict';

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        writable: true,
        configurable: true
      }
    });
    if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };
    return _getPrototypeOf(o);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;
      return o;
    };

    return _setPrototypeOf(o, p);
  }

  function _isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;

    try {
      Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
      return true;
    } catch (e) {
      return false;
    }
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return self;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (typeof call === "object" || typeof call === "function")) {
      return call;
    }

    return _assertThisInitialized(self);
  }

  function _createSuper(Derived) {
    return function () {
      var Super = _getPrototypeOf(Derived),
          result;

      if (_isNativeReflectConstruct()) {
        var NewTarget = _getPrototypeOf(this).constructor;

        result = Reflect.construct(Super, arguments, NewTarget);
      } else {
        result = Super.apply(this, arguments);
      }

      return _possibleConstructorReturn(this, result);
    };
  }

  var e=function(){function t(t,e){this.name=t,this.slot=e||null,this.attributes=new Map;}return t.prototype.getName=function(){return this.name},t.prototype.getSlot=function(){return this.slot},t.prototype.getAttributes=function(){return this.attributes},t.slotLimit=function(e,n){return new t("limit",e).attr("n",n)},t.dataLimit=function(e){return new t("limit").attr("n",e)},t.prototype.attr=function(t,e){return this.attributes.set(t,e),this},t}(),n=function(t,e){return (n=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e;}||function(t,e){for(var n in e)e.hasOwnProperty(n)&&(t[n]=e[n]);})(t,e)};function r(t,e){function r(){this.constructor=t;}n(t,e),t.prototype=null===e?Object.create(e):(r.prototype=e.prototype,new r);}function o(t,e,n){return t.getDecoration(e,n)}function i(t){return t.hasDecoration("hasSelection")?o(t,"hasSelection",!1):!!function(t){return "getSlot"in t&&"hasDecorationOnDataPoints"in t}(t)&&t.hasDecorationOnDataPoints("selected")}var u,s=function(){function t(t,e){this.min=t,this.max=e;}return t.prototype.asArray=function(){return [this.min,this.max]},t.empty=new t(0,0),t}(),a=function(t){function e(e,n){return t.call(this,e,n)||this}return r(e,t),e.fromRS=function(t){return new s(t.min,t.max)},e}(s),l=function(){function t(t,e){this.source=t,this.index=e,this.key=t.getKey(!1),this.caption=t.getCaption("label")||"";var n=t.getItems()||[];this.segments=n.map(function(t){return new p(t)});}return Object.defineProperty(t.prototype,"selected",{get:function(){return o(this.source,"selected",!1)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"highlighted",{get:function(){return o(this.source,"highlighted",!1)},enumerable:!0,configurable:!0}),t}(),c=function(t){function e(e,n){return t.call(this,e,n)||this}return r(e,t),e}(l),h=function(){function t(t){this.source=t,this.key=this.source.getUniqueName()||"",this.caption=this.source.getCaption("label")||"";}return Object.defineProperty(t.prototype,"selected",{get:function(){return o(this.source,"selected",!1)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"highlighted",{get:function(){return o(this.source,"highlighted",!1)},enumerable:!0,configurable:!0}),t}(),p=function(t){function e(e){return t.call(this,e)||this}return r(e,t),e}(h),f=new(function(){function t(){}return t.prototype.format=function(t){return t?t.toString():""},t}());!function(t){t.label="label",t.data="data";}(u||(u={}));var g=function(){function t(t,e,n,r,o){this.source=t,this.tuples=e,this.segments=n,this.domain=r,this.caption=o;var i=t.dataItems||[],u=i.length>0?i[0]:null,s=u&&u.asCont();s?(this._labelFormatter=s.getFormatter("label")||f,this._dataFormatter=s.getFormatter("data")||f):this._labelFormatter=this._dataFormatter=f;}return Object.defineProperty(t.prototype,"mapped",{get:function(){return this.source.mapped},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"dataType",{get:function(){var t=this.source.getDataItem(0);return this.mapped&&t?t.type:"none"},enumerable:!0,configurable:!0}),t.prototype.format=function(t,e){return function(t,e){return t.format(e)}(e===u.data?this._dataFormatter:this._labelFormatter,t)},t}(),d=function(t){function e(e,n,r,o,i){return t.call(this,e,n,r,o,i)||this}return r(e,t),e}(g),m=function(){function t(t,e){this.source=t,this.key=t.getKey(!1),this.dataSet=e;}return Object.defineProperty(t.prototype,"selected",{get:function(){return o(this.source,"selected",!1)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"highlighted",{get:function(){return o(this.source,"highlighted",!1)},enumerable:!0,configurable:!0}),t.prototype.tuple=function(t){var e=this._getSlot(t);if(!e||0===e.tuples.length)return null;var n=this.source.get(e.source);if(!n)return null;var r=n.asCat();return r?e.tuples[r.index]:null},t.prototype.value=function(t){var e=this._getSlot(t),n=e&&this.source.get(e.source);if(!n)return null;var r=n.asCont();return r&&"numeric"===r.valueType?r.value:null},t.prototype.caption=function(t){var e=this._getSlot(t),n=e&&this.source.get(e.source);return n&&n.getCaption("data")||""},t.prototype._getSlot=function(t){return "string"==typeof t?this.dataSet.slotMap.get(t)||null:this.dataSet.cols[t]||null},t}(),y=function(t){function e(e,n){return t.call(this,e,n)||this}return r(e,t),e}(m),v=function(){function t(t,e,n){var r=this;this.source=t,this.rows=t.dataPoints.map(function(t){return new y(t,r)}),this.cols=e,this.slotMap=n;}return t.filterRows=function(t,e,n){return t.filter(function(t){var r=t.tuple(e);return !!r&&r.key===n})},Object.defineProperty(t.prototype,"hasSelections",{get:function(){return i(this.source)},enumerable:!0,configurable:!0}),t}(),_=function(t){function e(e,n,r){return t.call(this,e,n,r)||this}return r(e,t),e}(v);function b(t){var e=new Map,n=t.getSlots().map(function(t,n){var r=[],o=[],i=s.empty,u="";if(t.isMapped()){var l=t.getDataItem(0);if(u=l.getCaption("label"),"cat"===l.getRSType())r=l.getTuples().map(function(t,e){return new c(t,e)}),o=l.getItemClassSet(0).getItemClasses().map(function(t){return new p(t)});else i=a.fromRS(l.getDomain()),o.push(new p(l.getItemClass()));}var h=new d(t,r,o,i,u);return e.set(t.name,h),h});return new _(t,n,e)}function w(t){return t<0?0:t>255?255:Math.floor(t)}var C=function(){function t(t,e,n,r){var o;this.r=w(t),this.g=w(e),this.b=w(n),this.a=(o=r)<0?0:o>1?1:o;}return t.fromObject=function(e){return new t(e.r,e.g,e.b,void 0===e.a?1:e.a)},t.prototype.toString=function(){return 1===this.a?"rgb("+this.r+","+this.g+","+this.b+")":"rgba("+this.r+","+this.g+","+this.b+","+this.a+")"},t}();function S(t,e){var n=null;if(t instanceof m)n=t.source.getDataSet(e);else{var r=t.source.getDataItem(e);n=r&&r.getDataSet(e);}return !!n&&i(n)}var P=function(t){return "rgba("+t.r+","+t.g+","+t.b+",0.4)"},j=function(t){return "rgba("+.7*t.r+","+.7*t.g+","+.7*t.b+","+t.a+")"},x=function(){function t(t,e,n){this.source=t,this._dataContext=e,this._slotResolver=n;}return Object.defineProperty(t.prototype,"slot",{get:function(){return this.source.slot},enumerable:!0,configurable:!0}),t.prototype.getColor=function(t){return t?C.fromObject(this.source.getTupleColor(t.source,-1)):C.fromObject(this.source.getColor(null))},t.prototype._getTuple=function(t){if(t instanceof l)return t;var e=this.slot||this._slotResolver(t.dataSet,this.source.name);return e?t.tuple(e):null},t.prototype.getFillColor=function(t){if(null===t)return this.source.getColor(null).toString();var e,n=this._getTuple(t);return e=n?this.source.getTupleColor(n.source,-1):this.source.getColor(t.source),!t.selected&&S(t,this._dataContext)?P(e):e.toString()},t.prototype.getOutlineColor=function(t){if(null===t)return this.source.getColor(null).toString();var e,n=this._getTuple(t);return e=n?this.source.getTupleColor(n.source,-1):this.source.getColor(t.source),t.highlighted||t.selected&&S(t,this._dataContext)?j(e):null},t}(),O=function(){return function(t,e,n){this.color=t,this.at=e,this.value=n;}}();function I(t){return t.map(function(t){return new O(C.fromObject(t.color),t.at,t.value)})}var D=function(){function t(t,e,n){this.source=t,this._slot=e,this._dataContext=n,this.stops=I(t.stops),this.aligned=I(t.aligned),this.interpolate=t.interpolate;}return t.prototype.getColor=function(t){return C.fromObject(this.source.getColor(t))},t.prototype.getFillColor=function(t){var e=this._slot?Number(t.value(this._slot)):0,n=this.source.getColor(e);return !t.selected&&S(t,this._dataContext)?P(n):n.toString()},t.prototype.getOutlineColor=function(t){var e=this._slot?Number(t.value(this._slot)):0,n=this.source.getColor(e);return t.highlighted||t.selected&&S(t,this._dataContext)?j(n):null},t}(),E=function(){function t(t,e,n){this.source=t,this._dataContext=e,this._lastDataItem=null,this._cachedStops=null,this._slotResolver=n;}return Object.defineProperty(t.prototype,"slot",{get:function(){return this.source.slot},enumerable:!0,configurable:!0}),t.prototype.getColorStops=function(t){var e=t?t.source.getDataItem(0):null,n=e&&e.asCont(),r=n?n.getDomain(null):null,o=this.source.getColorStops(n,r),i=t?t.source.name:null;return new D(o,i,this._dataContext)},t.prototype._fetchColorStops=function(t){var e=t.source.getDataSet(this._dataContext),n=this.slot||this._slotResolver(t.dataSet,this.source.name),r=n?e.getSlot(n):null,o=r?r.getDataItem(0):null,i=o?o.asCont():null;if(this.source.dirty||!this._cachedStops||i!==this._lastDataItem){var u=i?i.getDomain(null):null,s=this.source.getColorStops(i,u);this._cachedStops=new D(s,r&&r.name,this._dataContext),this._lastDataItem=i;}return this._cachedStops},t.prototype.getFillColor=function(t){return this._fetchColorStops(t).getFillColor(t)},t.prototype.getOutlineColor=function(t){return this._fetchColorStops(t).getOutlineColor(t)},t}(),T=function(t){function e(e){var n=t.call(this,e.r,e.g,e.b,e.a)||this;return n._color=e,n}return r(e,t),e.prototype.getRed=function(){return this.r},e.prototype.getGreen=function(){return this.g},e.prototype.getBlue=function(){return this.b},e.prototype.getAlpha=function(){return this.a},e}(C),R=Object.freeze({min:0,max:0,empty:!0,explicit:!1,getMin:function(){return 0},getMax:function(){return 0},isEmpty:function(){return !0},isExplicit:function(){return !1}}),F=function(){function t(t,e,n,r,o,i){this.caption=t,this.color=e,this.shape=n,this.selected=r,this.highlighted=o,this.ref=i;}return t.prototype.getCaption=function(){return this.caption},t.prototype.getColor=function(){return this.color?new T(this.color):null},t.prototype.getShape=function(){return this.shape},t.prototype.isSelected=function(){return this.selected},t.prototype.isHighlighted=function(){return this.highlighted},t.prototype.getRef=function(){return this.ref},t}(),L=function(){function t(t,e,n,r,o,i){this.type=t,this.channel=e,this.slot=n,this.caption=r,this.subCaption=o,this.ref=i;}return t.prototype.getRSType=function(){return this.type},t.prototype.getChannel=function(){return this.channel},t.prototype.getSlot=function(){return this.slot},t.prototype.getCaption=function(){return this.caption},t.prototype.getSubCaption=function(){return this.subCaption},t.prototype.getRef=function(){return this.ref},t}(),M=function(t){function e(e,n,r,i,u){var s=this,a=n&&n.source,l=a&&a.name,c=a&&a.getDataItem(0),h=c&&c.asCat();s=t.call(this,"cat",e,l,r,"",h)||this;var p=h?h.tuples:[];return s.entries=p.map(function(t){var e=t.getCaption("label")||"",n=u&&u.source.getTupleColor(t,-1),r=o(t,"selected",!1),s=o(t,"highlighted",!1);return new F(e,n?C.fromObject(n):null,i,r,s,t)}),s}return r(e,t),e.prototype.getEntries=function(){return this.entries},e}(L),A=function(t){function e(e,n,r,o){var i=this,u=n&&n.source,s=u&&u.name,a=u&&u.getDataItem(0),l=a&&a.asCont();if((i=t.call(this,"cont",e,s,r,"",l)||this).domain=l?l.getDomain(null):R,o&&"color"===e){var c=o.source.getColorStops(l,null);i.stops=c.stops,i.interpolate=c.interpolate;}else i.stops=null,i.interpolate=!1;return i}return r(e,t),e.prototype.getDomain=function(){return this.domain},e.prototype.getInterpolate=function(){return this.interpolate},e.prototype.getStops=function(){return this.stops},e}(L);function z(t,e,n,r){if(!t)return [];var o=new Map,i=new Map;e.palettes.forEach(function(e){var n=e.slot||r&&r(t,e.source.name);n&&(e instanceof x?o.set(n,e):e instanceof E&&i.set(n,e));});var u=[];return t.cols.forEach(function(t){var e=t.source;if(e.mapped){var r=e.getDataItem(0);if(r)switch(r.type){case"cat":if(-1===e.channels.indexOf("color"))return;var s=o.get(e.name);s&&u.push(new M("color",t,t.caption,n.legendShape,s));break;case"cont":if(-1!==e.channels.indexOf("color")){var a=i.get(e.name);a&&u.push(new A("color",t,t.caption,a));}-1!==e.channels.indexOf("size")&&u.push(new A("size",t,t.caption,null));}}}),u}var N,k=function(){return function(){this.legendShape=null,this.slotLimits=new Map,this.dataLimit=-1;}}();!function(t){t.Em="em",t.Percentage="%",t.Centimeter="cm",t.Millimeter="mm",t.Inch="in",t.Pica="pc",t.Point="pt",t.Pixel="px";}(N||(N={}));var H,U,V=function(){function t(t,e){this.value=t,this.unit=e;}return t.fromObject=function(e){return new t(e.value,function(t){switch(t){case"em":return N.Em;case"%":return N.Percentage;case"cm":return N.Centimeter;case"mm":return N.Millimeter;case"in":return N.Inch;case"pc":return N.Pica;case"pt":return N.Point;case"px":return N.Pixel;default:throw new Error("Invalid length unit '"+t+"' specified")}}(e.unit))},t.prototype.toString=function(){return ""+this.value+this.unit},t}();!function(t){t.Normal="normal",t.Italic="italic";}(H||(H={})),function(t){t[t.Thin=100]="Thin",t[t.ExtraLight=200]="ExtraLight",t[t.Light=300]="Light",t[t.Normal=400]="Normal",t[t.Medium=500]="Medium",t[t.SemiBold=600]="SemiBold",t[t.Bold=700]="Bold",t[t.ExtraBold=800]="ExtraBold",t[t.Heavy=900]="Heavy";}(U||(U={}));var q=/\s+/g;function K(t){switch(t){case U.Normal:return "normal";case U.Bold:return "bold";case U.Thin:case U.ExtraLight:case U.Light:case U.Medium:case U.SemiBold:case U.ExtraBold:case U.Heavy:return t.toString();default:return ""}}function G(t){var e=[];if(t)for(var n=0,r=t.length;n<r;++n){var o=t[n],i=q.test(o);e.push(i?'"'+o+'"':o);}return e.join(", ")}var J=function(){function t(t,e,n,r){this.family=t,this.size=e,this.style=n,this.weight=r;}return t.fromObject=function(e){return new t(e.family||null,e.size?V.fromObject(e.size):null,e.style?function(t){switch(t){case"normal":return H.Normal;case"italic":return H.Italic;default:throw new Error("Invalid font style '"+t+"' specified")}}(e.style):null,void 0!==e.weight&&null!==e.weight?e.weight:null)},t.prototype.toString=function(){if(this.style!==H.Normal&&this.weight!==U.Normal||this.style===H.Normal&&this.weight===U.Normal){var t=[];return this.style===H.Normal?t.push("normal"):(this.style&&t.push(this.style),this.weight&&t.push(K(this.weight))),this.size&&t.push(this.size.toString()),this.family&&t.push(G(this.family)),t.join(" ")}return function(t){var e,n=[],r=G(t.family);return r.length>0&&n.push("font-family: "+r+";"),(r=t.size?t.size.toString():"").length>0&&n.push("font-size: "+r+";"),(r=(e=t.style)?e.toString():"").length>0&&n.push("font-style: "+r+";"),(r=K(t.weight)).length>0&&n.push("font-weight: "+r+";"),n.join(" ")}(this)},t}(),Q=function(){function t(t,e,n){var r=new Map;null!==t&&t.forEach(function(t,o){if("palette"===t.type){var i=t;switch(i.paletteType){case"cat":r.set(o,new x(i,e,n));break;case"cont":r.set(o,new E(i,e,n));}}}),this.source=t,this.palettes=r;}return t.prototype.get=function(t){return this._getValue(t,!1)},t.prototype.peek=function(t){return this._getValue(t,!0)},t.prototype._getValue=function(t,e){var n=this.source&&this.source.get(t);if(!n)return null;switch(n.type){case"string":case"number":case"boolean":case"enum":return e?n.peek:n.value;case"length":var r=e?n.peek:n.value;return r?V.fromObject(r):null;case"font":var o=e?n.peek:n.value;return o?J.fromObject(o):null;case"color":var i=e?n.peek:n.value;return i?C.fromObject(i):null;case"palette":return this.palettes.get(t)||null;default:return null}},t.prototype.isActive=function(t){var e=this.source&&this.source.get(t);return !!e&&e.active},t.prototype.setActive=function(t,e){var n=this.source&&this.source.get(t);n&&n.setActive(e);},t.prototype.isDirty=function(t){var e=this.source&&this.source.get(t);return !!e&&e.dirty},t}();var W=setTimeout;function X(t){return Boolean(t&&void 0!==t.length)}function Y(){}function Z(t){if(!(this instanceof Z))throw new TypeError("Promises must be constructed via new");if("function"!=typeof t)throw new TypeError("not a function");this._state=0,this._handled=!1,this._value=void 0,this._deferreds=[],ot(t,this);}function $(t,e){for(;3===t._state;)t=t._value;0!==t._state?(t._handled=!0,Z._immediateFn(function(){var n=1===t._state?e.onFulfilled:e.onRejected;if(null!==n){var r;try{r=n(t._value);}catch(t){return void et(e.promise,t)}tt(e.promise,r);}else(1===t._state?tt:et)(e.promise,t._value);})):t._deferreds.push(e);}function tt(t,e){try{if(e===t)throw new TypeError("A promise cannot be resolved with itself.");if(e&&("object"==typeof e||"function"==typeof e)){var n=e.then;if(e instanceof Z)return t._state=3,t._value=e,void nt(t);if("function"==typeof n)return void ot((r=n,o=e,function(){r.apply(o,arguments);}),t)}t._state=1,t._value=e,nt(t);}catch(e){et(t,e);}var r,o;}function et(t,e){t._state=2,t._value=e,nt(t);}function nt(t){2===t._state&&0===t._deferreds.length&&Z._immediateFn(function(){t._handled||Z._unhandledRejectionFn(t._value);});for(var e=0,n=t._deferreds.length;e<n;e++)$(t,t._deferreds[e]);t._deferreds=null;}function rt(t,e,n){this.onFulfilled="function"==typeof t?t:null,this.onRejected="function"==typeof e?e:null,this.promise=n;}function ot(t,e){var n=!1;try{t(function(t){n||(n=!0,tt(e,t));},function(t){n||(n=!0,et(e,t));});}catch(t){if(n)return;n=!0,et(e,t);}}Z.prototype.catch=function(t){return this.then(null,t)},Z.prototype.then=function(t,e){var n=new this.constructor(Y);return $(this,new rt(t,e,n)),n},Z.prototype.finally=function(t){var e=this.constructor;return this.then(function(n){return e.resolve(t()).then(function(){return n})},function(n){return e.resolve(t()).then(function(){return e.reject(n)})})},Z.all=function(t){return new Z(function(e,n){if(!X(t))return n(new TypeError("Promise.all accepts an array"));var r=Array.prototype.slice.call(t);if(0===r.length)return e([]);var o=r.length;function i(t,u){try{if(u&&("object"==typeof u||"function"==typeof u)){var s=u.then;if("function"==typeof s)return void s.call(u,function(e){i(t,e);},n)}r[t]=u,0==--o&&e(r);}catch(t){n(t);}}for(var u=0;u<r.length;u++)i(u,r[u]);})},Z.resolve=function(t){return t&&"object"==typeof t&&t.constructor===Z?t:new Z(function(e){e(t);})},Z.reject=function(t){return new Z(function(e,n){n(t);})},Z.race=function(t){return new Z(function(e,n){if(!X(t))return n(new TypeError("Promise.race accepts an array"));for(var r=0,o=t.length;r<o;r++)Z.resolve(t[r]).then(e,n);})},Z._immediateFn="function"==typeof setImmediate&&function(t){setImmediate(t);}||function(t){W(t,0);},Z._unhandledRejectionFn=function(t){"undefined"!=typeof console&&console&&console.warn("Possible Unhandled Promise Rejection:",t);};var it=function(){return function(t,e,n,r){this.data=t,this.decorations=e,this.properties=n,this.size=r;}}(),ut=function(){return function(t,e,n,r,o){this.reason=t,this.data=e,this.node=n,this.props=r,this.locale=o;}}();var st=function(){function n(){this._data=null,this._elem=null,this._nls=null,this._locale="en-us",this._slotResolver=this.getSlotForPalette.bind(this),this.properties=new Q(null,null,this._slotResolver),this.meta=new k;}return n.prototype.init=function(t,e){var n=this,r=t.surface.appendChild(document.createElement("div"));r.setAttribute("style","left: 0; top: 0; width: 100%; height: 100%; position: absolute"),r.setAttribute("data-charttype","custom-viz"),this.properties=new Q(t.properties,t.dataContext,this._slotResolver),this._nls=t.nls,this._locale=t.locale,Z.resolve(this.create(r)).then(function(o){n._elem=o||r,t.properties.forEach(function(t,e){return n.updateProperty(e,t.value)}),e.complete();}).catch(function(t){e.fail(t);});},n.prototype.destroy=function(){},n.prototype.getPropertyApi=function(){return null},n.prototype.setData=function(t){t&&t.dataSets&&t.dataSets[0]?this._data=b(t.dataSets[0]):this._data=null;},n.prototype.setProperty=function(t,e){this.updateProperty(t,this.properties.peek(t));},n.prototype.getBlockingRequests=function(){return null},n.prototype.render=function(t,e,n){if(!this._elem)return n.complete(null,null,null),null;if(!(e.data||e.decorations||e.properties||e.size))return n.complete(null,null,null),null;try{var r=this.update(new ut(function(t){return new it(t.data,t.decorations,t.properties,t.size)}(e),this._data,this._elem,this.properties,this._locale));Z.resolve(r).then(function(){return n.complete(null,null,null)}).catch(n.error);}catch(t){n.error(t);}return null},n.prototype.getEncodings=function(){return this._data?this.updateLegend(this._data):[]},n.prototype.getCapabilities=function(){var t=[];return this.meta.slotLimits.forEach(function(n,r){t.push(e.slotLimit(r,n));}),this.meta.dataLimit>=0&&t.push(e.dataLimit(this.meta.dataLimit)),t},n.prototype.getInteractivity=function(){return null},n.prototype.getVisCoordinate=function(t,e){return e},n.prototype.getRegionAtPoint=function(t,e){return null},n.prototype.getItemsAtPoint=function(t,e,n){if(!t||!t.hasOwnProperty("x")||!t.hasOwnProperty("y"))return null;var r=t,o=document.elementFromPoint(r.x,r.y),i=this.hitTest(o,r,e);return i&&i.source?[i.source]:[]},n.prototype.getItemsInPolygon=function(t,e){return []},n.prototype.getAxisItemsAtPoint=function(t,e,n){return []},n.prototype.getState=function(){return null},n.prototype.setState=function(t){},n.prototype.loadCss=function(t){var e=document.createElement("link");e.type="text/css",e.rel="stylesheet",e.href=this.toUrl(t),document.getElementsByTagName("head")[0].appendChild(e);},n.prototype.toUrl=function(e){return requirejs.toUrl(e)},n.prototype.update=function(t){},n.prototype.create=function(t){},n.prototype.updateProperty=function(t,e){},n.prototype.updateLegend=function(t){return z(t,this.properties,this.meta,this._slotResolver)},n.prototype.getSlotForPalette=function(t,e){return null},n.prototype.hitTest=function(t,e,n){var r=t&&t.__data__;return r&&r.source?r:null},n.prototype.nls=function(t){return this._nls&&this._nls.get(t)||""},n}();

  var SIZE = 1,
      HEAT = 2;
  /**
   * Used for hierarchical structures
   * A node contains either an array of nodes as children
   * or a DataPoint instance (leaf node)
   */

  var TreeNode = /*#__PURE__*/function () {
    function TreeNode(name) {
      _classCallCheck(this, TreeNode);

      _defineProperty(this, "name", void 0);

      _defineProperty(this, "heat", void 0);

      _defineProperty(this, "size", void 0);

      _defineProperty(this, "children", void 0);

      _defineProperty(this, "dataPoint", void 0);

      this.name = name;
    }
    /**
     * Add a node to children array and return its index
     * @param child
     */


    _createClass(TreeNode, [{
      key: "addChild",
      value: function addChild(child) {
        if (!this.children) this.children = new Array();
        this.children.push(child);
        return this.children.length - 1;
      }
      /**
       * Find a child node in the children array and return its index
       * @param childName Name of the child node
       */

    }, {
      key: "findChild",
      value: function findChild(childName) {
        if (!this.children) return -1; // No children

        for (var i = 0, len = this.children.length; i < len; ++i) {
          if (this.children[i].name === childName) return i;
        }

        return -1; // Child not found
      }
      /**
       * Set data point and assign heat and size, only for leave node
       * @param row DataPoint
       */

    }, {
      key: "setData",
      value: function setData(row) {
        this.dataPoint = row;
        this.heat = row.value(HEAT);
        this.size = row.value(SIZE);
      }
      /**
       * Calculate and return size (sum of children' size) of a node recursively
       */

    }, {
      key: "_getSize",
      value: function _getSize() {
        if (this.size !== undefined) return this.size;
        this.size = this.children.map(function (e) {
          return e._getSize();
        }).reduce(function (a, b) {
          return a + b;
        }, 0);
        return this.size;
      }
      /**
       * Calculate and return heat (weighted average of children' size and heat) of a node recursively
       */

    }, {
      key: "_getHeat",
      value: function _getHeat() {
        if (this.heat !== undefined) return this.heat;
        this.heat = this.children.map(function (e) {
          return e._getSize() * e._getHeat();
        }).reduce(function (a, b) {
          return a + b;
        }, 0) / this._getSize();
        return this.heat;
      }
      /**
       * Calculate heat and size of a node and its descandants
       * Call this function after creating the tree and before processing it further (using heat and size)
       */

    }, {
      key: "calculateHeatAndSize",
      value: function calculateHeatAndSize() {
        this._getHeat();
      }
      /**
       * Determine if a node is highlighted (if one of its children is highlighted)
       */

    }, {
      key: "isHighlighted",
      value: function isHighlighted() {
        if (this.dataPoint) return this.dataPoint.highlighted;
        return this.children.some(function (child) {
          return child.isHighlighted();
        });
      }
      /**
       * Determine if a node is selected (if one of its children is selected)
       */

    }, {
      key: "isSelected",
      value: function isSelected() {
        if (this.dataPoint) return this.dataPoint.selected;
        return this.children.some(function (child) {
          return child.isSelected();
        });
      }
    }]);

    return TreeNode;
  }();

  var HIERARCHY = 0,
      HEAT$1 = 2;
  var TITLE_HEIGHT = 15,
      PADDING = 1;
  var MINIMUM_PROPORTION = 0.002;
  var MINIMUM_HEIGHT_STOCK_LABEL = 30;
  var MINIMUM_WIDTH_STOCK_HEAT = 50,
      MINIMUM_HEIGHT_STOCK_HEAT = 40;
  var GROUP_LABEL_FONT_SIZE = 11;
  /**
   * Calculate the hierarchy of data, based on HIERARCHY value of rows
   * @param _data
   */

  function hierarchicalData(_data) {
    var tree = new TreeNode("root");

    _data.rows.forEach(function (row) {
      var hierarchy = row.tuple(HIERARCHY).segments.map(function (e) {
        return e.caption;
      });
      var nodeName = hierarchy.pop();
      var treeLevel = tree; // Iterate treeLevel as pointer through each level of hierarchy

      hierarchy.forEach(function (key) {
        var treeNodeIndex = treeLevel.findChild(key);

        if (treeNodeIndex < 0) // Hierarchy not found, creating
          {
            var newNode = new TreeNode(key);
            treeNodeIndex = treeLevel.addChild(newNode);
          }

        treeLevel = treeLevel.children[treeNodeIndex];
      });
      var leafNodeData = new TreeNode(nodeName);
      leafNodeData.setData(row);
      treeLevel.addChild(leafNodeData);
      treeLevel = tree;
    });

    return tree;
  }
  /**
   * Generate function to check if a group title should be rendered
   * @param root Root node
   */


  function createCheckGroupTitleVisibleFn(root) {
    // Minimum size to show group label is MINIMUM_PROPORTION of root size
    var minimumSize = root.value * MINIMUM_PROPORTION;
    return function (_node) {
      return _node.value > minimumSize;
    };
  }
  /**
   * Generate function to check if a stock name should be shown
   * @param _svgElem
   */


  function createCheckStockNameVisibleFn(_svgElem) {
    var padding = 15;
    return function (_leaf) {
      var name = _leaf.data.name;
      var width = _leaf["x1"] - _leaf["x0"];
      var height = _leaf["y1"] - _leaf["y0"];
      _svgElem.textContent = name;
      return _svgElem.getComputedTextLength() <= width - padding && height >= MINIMUM_HEIGHT_STOCK_LABEL;
    };
  }
  /**
   * Generate function to check if a stock heat should be shown
   * @param _isStockNameVisible Function that return a boolean if stock name is visible
   */


  function createCheckStockHeatVisibleFn(_isStockNameVisible) {
    return function (_leaf) {
      var width = _leaf["x1"] - _leaf["x0"];
      var height = _leaf["y1"] - _leaf["y0"];
      return width >= MINIMUM_WIDTH_STOCK_HEAT && height >= MINIMUM_HEIGHT_STOCK_HEAT && _isStockNameVisible(_leaf);
    };
  }
  /**
   * Return offset if only stock name is shown
   * @param _isStockNameVisible
   * @param _isStockHeatVisible
   */


  function createGetStockLabelOffsetFn(_isStockNameVisible, _isStockHeatVisible, showStockValue) {
    return function (_leaf) {
      return !showStockValue || _isStockNameVisible(_leaf) && !_isStockHeatVisible(_leaf) ? 5 : 0;
    };
  }
  /**
   * Generate function that trims the group title until it fits the container
   * @param _svgElem SVGTextElement having font-size same as the group title
   */


  function createTrimGroupTitleFn(_svgElem) {
    var padding = 10;
    return function (_node) {
      var maxWidth = _node["x1"] - _node["x0"] - padding;
      var name = _node.data.name;
      _svgElem.textContent = name;
      var i;

      for (i = name.length; i > 0 && _svgElem.getSubStringLength(0, i) > maxWidth; i = i - 3) {
      }

      for (i; i < name.length && _svgElem.getSubStringLength(0, i + 1) <= maxWidth; ++i) {
      }

      return name.substr(0, i);
    };
  }
  /**
   * Generate coordinates of the polygon for the group title
   * @param _node Group node, direct parents of leaves
   */


  function getGroupTitleContainerCoordinates(_node) {
    var x0 = _node["x0"];
    var x1 = _node["x1"];
    var y0 = _node["y0"];
    var coordinates = [[x0 + PADDING, y0], [x1 - PADDING * 2, y0], [x1 - PADDING * 2, y0 + TITLE_HEIGHT - PADDING], [x0 + TITLE_HEIGHT, y0 + TITLE_HEIGHT - PADDING], [x0 + 0.75 * TITLE_HEIGHT, y0 + 1.25 * TITLE_HEIGHT - PADDING], [x0 + 0.5 * TITLE_HEIGHT, y0 + TITLE_HEIGHT - PADDING], [x0 + PADDING, y0 + TITLE_HEIGHT - PADDING]];
    return coordinates;
  }

  var transparent = function transparent(color) {
    return "rgba(".concat(color.r, ",").concat(color.g, ",").concat(color.b, ",0.4)");
  };

  var darker = function darker(color) {
    return "rgba(".concat(0.7 * color.r, ",").concat(0.7 * color.g, ",").concat(0.7 * color.b, ",").concat(color.a, ")");
  };
  /**
   * Generate styling functions for group label container
   * @param _colorStops
   * @param _hasSelections If any data row is selected
   */


  function createGroupLabelStyleFn(_colorStops, _hasSelections) {
    return function (_node, _elem) {
      var highlighted = _node.data.isHighlighted();

      var selected = _node.data.isSelected();

      var color = _colorStops.getColor(_node.data.heat);

      var stroke = highlighted || selected ? darker(color) : "white";
      var strokeWidth = highlighted || selected ? "2px" : "1px";
      var fillColor = !selected && _hasSelections ? transparent(color) : color;
      var elem = d3.select(_elem);
      elem.style("stroke", stroke);
      elem.style("stroke-width", strokeWidth);
      elem.style("fill", fillColor.toString());
    };
  }
  /**
   * Create function that format stock heat using the host's formatter
   * @param _col Heat column
   */


  function createFormatStockHeatFn(_col) {
    return function (_leaf) {
      var value = _leaf.data.heat;

      var formattedValue = _col.format(value);

      return value > 0 ? "+" + formattedValue : formattedValue;
    };
  }

  var _default = /*#__PURE__*/function (_RenderBase) {
    _inherits(_default, _RenderBase);

    var _super = _createSuper(_default);

    function _default() {
      var _this;

      _classCallCheck(this, _default);

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      _this = _super.call.apply(_super, [this].concat(args));

      _defineProperty(_assertThisInitialized(_this), "_root", void 0);

      return _this;
    }

    _createClass(_default, [{
      key: "create",
      value: function create(_node) {
        var svg = d3.select(_node).append("svg").attr("width", "100%").attr("height", "100%");
        var chart = svg.append("g").attr("class", "chart");
        chart.append("g").attr("class", "elem data");
        chart.append("g").attr("class", "names data");
        chart.append("g").attr("class", "values data");
        chart.append("g").attr("class", "smallTitles titles data");
        chart.append("g").attr("class", "bigTitles titles data");
        return svg.node();
      }
    }, {
      key: "update",
      value: function update(_info) {
        var data = _info.data;
        var node = _info.node;
        var svg = d3.select(node);
        var props = _info.props;
        var updateReason = _info.reason;
        var width = node.clientWidth;
        var height = node.clientHeight;
        var palette = props.get("color");
        var showHierarchy = props.get("text.showGroup");
        var showStockName = props.get("text.showName");
        var showStockValue = props.get("text.showValue");
        var textColor = props.get("text.color");

        if (!data) {
          svg.selectAll(".data>*").remove();
          return;
        }

        svg.call(d3.zoom().extent([[0, 0], [width, height]]).scaleExtent([1, 4]).translateExtent([[0, 0], [width, height]]).on("zoom", function () {
          return svg.select(".chart").attr("transform", d3.event.transform);
        }));

        if (updateReason.data) {
          // Using treemap to calculate coordinate from hierarchical data format
          var hierarchyData = hierarchicalData(data);
          this._root = d3.hierarchy(hierarchyData, function (d) {
            return d.children;
          }).sum(function (d) {
            return Math.max(d.size, 0);
          }) // Ignore negative data values
          .sort(function (a, b) {
            return b.value - a.value;
          }); // Calculate heat for all nodes, recursively

          this._root.data.calculateHeatAndSize();
        }

        var isGroupTitleVisible = createCheckGroupTitleVisibleFn(this._root);
        if (updateReason.data || updateReason.size || updateReason.properties) d3.treemap().size([width, height]).tile(d3.treemapBinary).round(true).padding(PADDING).paddingTop(function (d) {
          return isGroupTitleVisible(d) && showHierarchy ? TITLE_HEIGHT : PADDING;
        }).paddingRight(PADDING * 2)(this._root); // Label of small groups (parents of leaves)

        var nodesWithSmallLabel = this._root.descendants().filter(function (node) {
          return node.height === 1 && node.depth > 0 && isGroupTitleVisible(node);
        });

        var leaves = this._root.leaves().filter(function (leaf) {
          return leaf.data.size > 0;
        });

        if (updateReason.data || updateReason.size || updateReason.properties) {
          // Draw treemap
          svg.select(".elem").selectAll("rect").data(leaves).join("rect").attr("x", function (leaf) {
            return leaf["x0"];
          }).attr("y", function (leaf) {
            return leaf["y0"];
          }).attr("width", function (leaf) {
            return leaf["x1"] - leaf["x0"];
          }).attr("height", function (leaf) {
            return leaf["y1"] - leaf["y0"];
          }).attr("stroke-width", 2);
          var dummySvg = svg.select(".elem").selectAll("text").data([null]).join("text").style("visibility", "hidden").style("font-size", "1em");
          var isStockNameVisible = createCheckStockNameVisibleFn(dummySvg.node());
          var isStockHeatVisible = createCheckStockHeatVisibleFn(isStockNameVisible);
          var getStockLabelOffset = createGetStockLabelOffsetFn(isStockNameVisible, isStockHeatVisible, showStockValue);
          var formatStockHeat = createFormatStockHeatFn(data.cols[HEAT$1]);
          if (showStockName) svg.select(".names").selectAll("text").data(leaves.filter(function (node) {
            return isStockNameVisible(node);
          })).join("text").attr("x", function (leaf) {
            return leaf["x0"] + (leaf["x1"] - leaf["x0"]) / 2;
          }).attr("y", function (leaf) {
            return leaf["y0"] + (leaf["y1"] - leaf["y0"]) / 2 + getStockLabelOffset(leaf);
          }).text(function (leaf) {
            return leaf.data.name;
          }).style("text-anchor", "middle").attr("fill", textColor.toString());else svg.selectAll(".names").html(null);
          if (showStockValue) svg.select(".values").selectAll("text").data(leaves.filter(function (node) {
            return isStockHeatVisible(node);
          })).join("text").attr("x", function (leaf) {
            return leaf["x0"] + (leaf["x1"] - leaf["x0"]) / 2;
          }).attr("y", function (leaf) {
            return leaf["y0"] + (leaf["y1"] - leaf["y0"]) / 2 + 15;
          }).text(function (leaf) {
            return formatStockHeat(leaf);
          }).attr("font-size", "0.8em").style("text-anchor", "middle").attr("fill", textColor.toString());else svg.selectAll(".values").html(null);

          if (showHierarchy) {
            dummySvg.style("font-size", GROUP_LABEL_FONT_SIZE + "px");
            var formatGroupTitle = createTrimGroupTitleFn(dummySvg.node()); // Parent of leaves label container

            svg.select(".smallTitles").selectAll("polygon").data(nodesWithSmallLabel).join("polygon").attr("points", function (node) {
              return getGroupTitleContainerCoordinates(node).map(function (e) {
                return e[0] + "," + e[1];
              }).join(" ");
            }); // Parent of leaves (small label)

            svg.select(".smallTitles").selectAll("text").data(nodesWithSmallLabel).join("text").attr("x", function (node) {
              return node["x0"] + 3;
            }).attr("y", function (node) {
              return node["y0"] + 11;
            }).attr("fill", textColor.toString()).attr("font-size", GROUP_LABEL_FONT_SIZE + "px").text(function (node) {
              return formatGroupTitle(node);
            }); // Big group label (leaves' grandparents and above, exclude root)

            svg.select(".bigTitles").selectAll("text").data(this._root.descendants().filter(function (node) {
              return node.depth > 0 && node.height > 1 && isGroupTitleVisible(node);
            })).join("text").attr("x", function (node) {
              return node["x0"] + 3;
            }).attr("y", function (node) {
              return node["y0"] + 11;
            }).attr("font-size", GROUP_LABEL_FONT_SIZE + 1 + "px").text(function (node) {
              return formatGroupTitle(node);
            });
          } else {
            svg.selectAll(".smallTitles").html(null);
            svg.selectAll(".bigTitles").html(null);
          }
        } // Color styling


        svg.select(".elem").selectAll("rect").data(leaves).join("rect").attr("stroke", function (leaf) {
          return palette.getOutlineColor(leaf.data.dataPoint);
        }).style("fill", function (leaf) {
          return palette.getFillColor(leaf.data.dataPoint);
        });

        if (showHierarchy) {
          var groupLabelStyle = createGroupLabelStyleFn(palette.getColorStops(data.cols[HEAT$1]), data.hasSelections);
          svg.select(".smallTitles").selectAll("polygon").data(nodesWithSmallLabel).join("polygon").each(function (d, i, groups) {
            return groupLabelStyle(d, groups[i]);
          });
        }
      }
    }, {
      key: "hitTest",
      value: function hitTest(_elem) {
        // Retrieve the d3 datum of the element that was hit.
        var elem = d3.select(_elem);
        var node = elem.empty() ? null : elem.datum(); // If parent of a leaf was hit, return all of its children

        if (node && node.height === 1) {
          var segments = node.data.children[0].dataPoint.tuple(HIERARCHY).segments;
          return segments[segments.length - 2];
        } // If there was data on the element, return its DataPoint.


        return node && node.data && node.data.dataPoint;
      }
    }]);

    return _default;
  }(st);

  return _default;

});
